Index: lemon/Makefile.am
===================================================================
--- lemon/Makefile.am	(revision 1979)
+++ lemon/Makefile.am	(revision 1993)
@@ -46,5 +46,4 @@
 	graph_to_eps.h \
 	hypercube_graph.h \
-	invalid.h \
 	iterable_maps.h \
 	johnson.h \
@@ -75,10 +74,8 @@
 	time_measure.h \
 	topology.h \
-	traits.h \
 	ugraph_adaptor.h \
 	unionfind.h \
 	xy.h \
 	concept_check.h \
-	utility.h \
 	lemon_reader.h \
 	lemon_writer.h \
@@ -95,6 +92,9 @@
 	bits/graph_adaptor_extender.h \
 	bits/edge_set_extender.h \
+	bits/invalid.h \
 	bits/item_reader.h \
 	bits/item_writer.h \
+	bits/traits.h \
+	bits/utility.h \
 	concept/bpugraph.h \
 	concept/graph.h \
Index: lemon/base.cc
===================================================================
--- lemon/base.cc	(revision 1956)
+++ lemon/base.cc	(revision 1993)
@@ -21,5 +21,5 @@
 
 #include<lemon/tolerance.h>
-#include<lemon/invalid.h>
+#include<lemon/bits/invalid.h>
 namespace lemon {
 
Index: lemon/bellman_ford.h
===================================================================
--- lemon/bellman_ford.h	(revision 1956)
+++ lemon/bellman_ford.h	(revision 1993)
@@ -26,5 +26,5 @@
 
 #include <lemon/list_graph.h>
-#include <lemon/invalid.h>
+#include <lemon/bits/invalid.h>
 #include <lemon/error.h>
 #include <lemon/maps.h>
Index: lemon/bfs.h
===================================================================
--- lemon/bfs.h	(revision 1956)
+++ lemon/bfs.h	(revision 1993)
@@ -26,5 +26,5 @@
 #include <lemon/list_graph.h>
 #include <lemon/graph_utils.h>
-#include <lemon/invalid.h>
+#include <lemon/bits/invalid.h>
 #include <lemon/error.h>
 #include <lemon/maps.h>
Index: lemon/bits/graph_extender.h
===================================================================
--- lemon/bits/graph_extender.h	(revision 1991)
+++ lemon/bits/graph_extender.h	(revision 1993)
@@ -20,5 +20,5 @@
 #define LEMON_GRAPH_EXTENDER_H
 
-#include <lemon/invalid.h>
+#include <lemon/bits/invalid.h>
 #include <lemon/error.h>
 
Index: lemon/bits/invalid.h
===================================================================
--- lemon/bits/invalid.h	(revision 1993)
+++ lemon/bits/invalid.h	(revision 1993)
@@ -0,0 +1,54 @@
+/* -*- C++ -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2006
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
+#ifndef LEMON_BITS_INVALID_H
+#define LEMON_BITS_INVALID_H
+
+///\file
+///\brief Definition of INVALID.
+
+namespace lemon {
+
+  /// Dummy type to make it easier to make invalid iterators.
+  
+  /// See \ref INVALID, how to use it.
+  
+  struct Invalid {
+  public:
+    bool operator==(Invalid) { return true;  }
+    bool operator!=(Invalid) { return false; }
+    bool operator< (Invalid) { return false; }
+  };
+  
+  /// Invalid iterators.
+  
+  /// \ref Invalid is a global type that converts to each iterator
+  /// in such a way that the value of the target iterator will be invalid.
+
+  //const Invalid &INVALID = *(Invalid *)0;
+
+#ifdef LEMON_ONLY_TEMPLATES
+  const Invalid INVALID = Invalid();
+#else
+  extern const Invalid INVALID;
+#endif
+
+} //namespace lemon
+
+#endif
+  
Index: lemon/bits/map_extender.h
===================================================================
--- lemon/bits/map_extender.h	(revision 1956)
+++ lemon/bits/map_extender.h	(revision 1993)
@@ -22,5 +22,5 @@
 #include <iterator>
 
-#include <lemon/traits.h>
+#include <lemon/bits/traits.h>
 
 ///\file
Index: lemon/bits/static_map.h
===================================================================
--- lemon/bits/static_map.h	(revision 1979)
+++ lemon/bits/static_map.h	(revision 1993)
@@ -23,5 +23,5 @@
 #include <iostream>
 
-#include <lemon/utility.h>
+#include <lemon/bits/utility.h>
 #include <lemon/bits/map_extender.h>
 #include <lemon/bits/alteration_notifier.h>
Index: lemon/bits/traits.h
===================================================================
--- lemon/bits/traits.h	(revision 1993)
+++ lemon/bits/traits.h	(revision 1993)
@@ -0,0 +1,300 @@
+/* -*- C++ -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2006
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
+#ifndef LEMON_BITS_TRAITS_H
+#define LEMON_BITS_TRAITS_H
+
+#include <lemon/bits/utility.h>
+
+///\file
+///\brief Traits for graphs and maps
+///
+
+namespace lemon {
+  template <typename _Graph, typename _Item>
+  class ItemSetTraits {};
+  
+
+  template <typename Graph, typename Enable = void>
+  struct NodeNotifierIndicator {
+    typedef InvalidType Type;
+  };
+  template <typename Graph>
+  struct NodeNotifierIndicator<
+    Graph, 
+    typename enable_if<typename Graph::NodeNotifier::Notifier, void>::type
+  > { 
+    typedef typename Graph::NodeNotifier Type;
+  };
+
+  template <typename _Graph>
+  class ItemSetTraits<_Graph, typename _Graph::Node> {
+  public:
+    
+    typedef _Graph Graph;
+
+    typedef typename Graph::Node Item;
+    typedef typename Graph::NodeIt ItemIt;
+
+    typedef typename NodeNotifierIndicator<Graph>::Type ItemNotifier;
+
+    template <typename _Value>
+    class Map : public Graph::template NodeMap<_Value> {
+    public:
+      typedef typename Graph::template NodeMap<_Value> Parent; 
+      typedef typename Parent::Value Value;
+
+      Map(const Graph& _graph) : Parent(_graph) {}
+      Map(const Graph& _graph, const Value& _value) 
+	: Parent(_graph, _value) {}
+
+     };
+
+  };
+
+  template <typename Graph, typename Enable = void>
+  struct EdgeNotifierIndicator {
+    typedef InvalidType Type;
+  };
+  template <typename Graph>
+  struct EdgeNotifierIndicator<
+    Graph, 
+    typename enable_if<typename Graph::EdgeNotifier::Notifier, void>::type
+  > { 
+    typedef typename Graph::EdgeNotifier Type;
+  };
+
+  template <typename _Graph>
+  class ItemSetTraits<_Graph, typename _Graph::Edge> {
+  public:
+    
+    typedef _Graph Graph;
+
+    typedef typename Graph::Edge Item;
+    typedef typename Graph::EdgeIt ItemIt;
+
+    typedef typename EdgeNotifierIndicator<Graph>::Type ItemNotifier;
+
+    template <typename _Value>
+    class Map : public Graph::template EdgeMap<_Value> {
+    public:
+      typedef typename Graph::template EdgeMap<_Value> Parent; 
+      typedef typename Parent::Value Value;
+
+      Map(const Graph& _graph) : Parent(_graph) {}
+      Map(const Graph& _graph, const Value& _value) 
+	: Parent(_graph, _value) {}
+    };
+
+  };
+
+  template <typename Graph, typename Enable = void>
+  struct UEdgeNotifierIndicator {
+    typedef InvalidType Type;
+  };
+  template <typename Graph>
+  struct UEdgeNotifierIndicator<
+    Graph, 
+    typename enable_if<typename Graph::UEdgeNotifier::Notifier, void>::type
+  > { 
+    typedef typename Graph::UEdgeNotifier Type;
+  };
+
+  template <typename _Graph>
+  class ItemSetTraits<_Graph, typename _Graph::UEdge> {
+  public:
+    
+    typedef _Graph Graph;
+
+    typedef typename Graph::UEdge Item;
+    typedef typename Graph::UEdgeIt ItemIt;
+
+    typedef typename UEdgeNotifierIndicator<Graph>::Type ItemNotifier;
+
+    template <typename _Value>
+    class Map : public Graph::template UEdgeMap<_Value> {
+    public:
+      typedef typename Graph::template UEdgeMap<_Value> Parent; 
+      typedef typename Parent::Value Value;
+
+      Map(const Graph& _graph) : Parent(_graph) {}
+      Map(const Graph& _graph, const Value& _value) 
+	: Parent(_graph, _value) {}
+    };
+
+  };
+
+  template <typename Graph, typename Enable = void>
+  struct ANodeNotifierIndicator {
+    typedef InvalidType Type;
+  };
+  template <typename Graph>
+  struct ANodeNotifierIndicator<
+    Graph, 
+    typename enable_if<typename Graph::ANodeNotifier::Notifier, void>::type
+  > { 
+    typedef typename Graph::ANodeNotifier Type;
+  };
+
+  template <typename _Graph>
+  class ItemSetTraits<_Graph, typename _Graph::ANode> {
+  public:
+    
+    typedef _Graph Graph;
+
+    typedef typename Graph::ANode Item;
+    typedef typename Graph::ANodeIt ItemIt;
+
+    typedef typename ANodeNotifierIndicator<Graph>::Type ItemNotifier;
+
+    template <typename _Value>
+    class Map : public Graph::template ANodeMap<_Value> {
+    public:
+      typedef typename Graph::template ANodeMap<_Value> Parent; 
+      typedef typename Parent::Value Value;
+
+      Map(const Graph& _graph) : Parent(_graph) {}
+      Map(const Graph& _graph, const Value& _value) 
+	: Parent(_graph, _value) {}
+    };
+
+  };
+
+  template <typename Graph, typename Enable = void>
+  struct BNodeNotifierIndicator {
+    typedef InvalidType Type;
+  };
+  template <typename Graph>
+  struct BNodeNotifierIndicator<
+    Graph, 
+    typename enable_if<typename Graph::BNodeNotifier::Notifier, void>::type
+  > { 
+    typedef typename Graph::BNodeNotifier Type;
+  };
+
+  template <typename _Graph>
+  class ItemSetTraits<_Graph, typename _Graph::BNode> {
+  public:
+    
+    typedef _Graph Graph;
+
+    typedef typename Graph::BNode Item;
+    typedef typename Graph::BNodeIt ItemIt;
+
+    typedef typename BNodeNotifierIndicator<Graph>::Type ItemNotifier;
+
+    template <typename _Value>
+    class Map : public Graph::template BNodeMap<_Value> {
+    public:
+      typedef typename Graph::template BNodeMap<_Value> Parent; 
+      typedef typename Parent::Value Value;
+
+      Map(const Graph& _graph) : Parent(_graph) {}
+      Map(const Graph& _graph, const Value& _value) 
+	: Parent(_graph, _value) {}
+    };
+
+  };
+
+
+  template <typename Map, typename Enable = void>
+  struct MapTraits {
+    typedef False ReferenceMapTag;
+
+    typedef typename Map::Key Key;
+    typedef typename Map::Value Value;
+
+    typedef const Value ConstReturnValue;
+    typedef const Value ReturnValue;
+  };
+
+  template <typename Map>
+  struct MapTraits<
+    Map, typename enable_if<typename Map::ReferenceMapTag, void>::type > 
+  {
+    typedef True ReferenceMapTag;
+    
+    typedef typename Map::Key Key;
+    typedef typename Map::Value Value;
+
+    typedef typename Map::ConstReference ConstReturnValue;
+    typedef typename Map::Reference ReturnValue;
+
+    typedef typename Map::ConstReference ConstReference; 
+    typedef typename Map::Reference Reference;
+ };
+
+  // Indicators for the tags
+
+  template <typename Graph, typename Enable = void>
+  struct NodeNumTagIndicator {
+    static const bool value = false;
+  };
+
+  template <typename Graph>
+  struct NodeNumTagIndicator<
+    Graph, 
+    typename enable_if<typename Graph::NodeNumTag, void>::type
+  > {
+    static const bool value = true;
+  };
+
+  template <typename Graph, typename Enable = void>
+  struct EdgeNumTagIndicator {
+    static const bool value = false;
+  };
+
+  template <typename Graph>
+  struct EdgeNumTagIndicator<
+    Graph, 
+    typename enable_if<typename Graph::EdgeNumTag, void>::type
+  > {
+    static const bool value = true;
+  };
+
+  template <typename Graph, typename Enable = void>
+  struct FindEdgeTagIndicator {
+    static const bool value = false;
+  };
+
+  template <typename Graph>
+  struct FindEdgeTagIndicator<
+    Graph, 
+    typename enable_if<typename Graph::FindEdgeTag, void>::type
+  > {
+    static const bool value = true;
+  };
+
+  template <typename Graph, typename Enable = void>
+  struct UndirectedTagIndicator {
+    static const bool value = false;
+  };
+
+  template <typename Graph>
+  struct UndirectedTagIndicator<
+    Graph, 
+    typename enable_if<typename Graph::UndirectedTag, void>::type
+  > {
+    static const bool value = true;
+  };
+
+
+
+}
+
+#endif // LEMON_MAPS_H
Index: lemon/bits/utility.h
===================================================================
--- lemon/bits/utility.h	(revision 1993)
+++ lemon/bits/utility.h	(revision 1993)
@@ -0,0 +1,137 @@
+/* -*- C++ -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2006
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
+// This file contains a modified version of the enable_if library from BOOST.
+// See the appropriate copyright notice below.
+
+// Boost enable_if library
+
+// Copyright 2003 © The Trustees of Indiana University.
+
+// Use, modification, and distribution is subject to the Boost Software
+// License, Version 1.0. (See accompanying file LICENSE_1_0.txt or copy at
+// http://www.boost.org/LICENSE_1_0.txt)
+
+//    Authors: Jaakko Järvi (jajarvi at osl.iu.edu)
+//             Jeremiah Willcock (jewillco at osl.iu.edu)
+//             Andrew Lumsdaine (lums at osl.iu.edu)
+
+
+#ifndef LEMON_BITS_UTILITY_H
+#define LEMON_BITS_UTILITY_H
+
+///\file
+///\brief Miscellaneous basic utilities
+///
+///\todo Please rethink the organisation of the basic files like this.
+///E.g. this file might be merged with invalid.h.
+
+
+namespace lemon
+{
+
+  /// Basic type for defining "tags". A "YES" condition for \c enable_if.
+
+  /// Basic type for defining "tags". A "YES" condition for \c enable_if.
+  ///
+  ///\sa False
+  ///
+  /// \todo This should go to a separate "basic_types.h" (or something)
+  /// file.
+  struct True {
+    ///\e
+    static const bool value = true;
+  };
+
+  /// Basic type for defining "tags". A "NO" condition for \c enable_if.
+
+  /// Basic type for defining "tags". A "NO" condition for \c enable_if.
+  ///
+  ///\sa True
+  struct False {
+    ///\e
+    static const bool value = false;
+  };
+
+
+  class InvalidType {
+  private:
+    InvalidType();
+  };
+  
+
+  template <typename T>
+  struct Wrap {
+    const T &value;
+    Wrap(const T &t) : value(t) {}
+  };
+
+  /**************** dummy class to avoid ambiguity ****************/
+
+  template<int T> struct dummy { dummy(int) {} };
+
+  /**************** enable_if from BOOST ****************/
+ 
+  template <bool B, class T = void>
+  struct enable_if_c {
+    typedef T type;
+  };
+
+  template <class T>
+  struct enable_if_c<false, T> {};
+
+  template <class Cond, class T = void> 
+  struct enable_if : public enable_if_c<Cond::value, T> {};
+
+  template <bool B, class T>
+  struct lazy_enable_if_c {
+    typedef typename T::type type;
+  };
+
+  template <class T>
+  struct lazy_enable_if_c<false, T> {};
+
+  template <class Cond, class T> 
+  struct lazy_enable_if : public lazy_enable_if_c<Cond::value, T> {};
+
+
+  template <bool B, class T = void>
+  struct disable_if_c {
+    typedef T type;
+  };
+
+  template <class T>
+  struct disable_if_c<true, T> {};
+
+  template <class Cond, class T = void> 
+  struct disable_if : public disable_if_c<Cond::value, T> {};
+
+  template <bool B, class T>
+  struct lazy_disable_if_c {
+    typedef typename T::type type;
+  };
+
+  template <class T>
+  struct lazy_disable_if_c<true, T> {};
+
+  template <class Cond, class T> 
+  struct lazy_disable_if : public lazy_disable_if_c<Cond::value, T> {};
+
+} // namespace lemon
+
+#endif
Index: lemon/bits/vector_map.h
===================================================================
--- lemon/bits/vector_map.h	(revision 1956)
+++ lemon/bits/vector_map.h	(revision 1993)
@@ -23,5 +23,5 @@
 #include <algorithm>
 
-#include <lemon/utility.h>
+#include <lemon/bits/utility.h>
 #include <lemon/bits/map_extender.h>
 #include <lemon/bits/alteration_notifier.h>
Index: lemon/color.h
===================================================================
--- lemon/color.h	(revision 1971)
+++ lemon/color.h	(revision 1993)
@@ -31,5 +31,5 @@
 #include <cmath>
 
-#include<lemon/invalid.h>
+#include<lemon/bits/invalid.h>
 #include<lemon/xy.h>
 #include<lemon/maps.h>
Index: lemon/concept/bpugraph.h
===================================================================
--- lemon/concept/bpugraph.h	(revision 1979)
+++ lemon/concept/bpugraph.h	(revision 1993)
@@ -30,5 +30,5 @@
 #include <lemon/concept/ugraph.h>
 
-#include <lemon/utility.h>
+#include <lemon/bits/utility.h>
 
 namespace lemon {
Index: lemon/concept/graph.h
===================================================================
--- lemon/concept/graph.h	(revision 1979)
+++ lemon/concept/graph.h	(revision 1993)
@@ -24,6 +24,6 @@
 ///\brief Declaration of Graph.
 
-#include <lemon/invalid.h>
-#include <lemon/utility.h>
+#include <lemon/bits/invalid.h>
+#include <lemon/bits/utility.h>
 #include <lemon/concept/maps.h>
 #include <lemon/concept_check.h>
Index: lemon/concept/graph_component.h
===================================================================
--- lemon/concept/graph_component.h	(revision 1956)
+++ lemon/concept/graph_component.h	(revision 1993)
@@ -25,5 +25,5 @@
 #define LEMON_CONCEPT_GRAPH_COMPONENT_H
 
-#include <lemon/invalid.h>
+#include <lemon/bits/invalid.h>
 #include <lemon/concept/maps.h>
 
Index: lemon/concept/heap.h
===================================================================
--- lemon/concept/heap.h	(revision 1956)
+++ lemon/concept/heap.h	(revision 1993)
@@ -25,5 +25,5 @@
 #define LEMON_CONCEPT_HEAP_H
 
-#include <lemon/invalid.h>
+#include <lemon/bits/invalid.h>
 
 namespace lemon {
Index: lemon/concept/maps.h
===================================================================
--- lemon/concept/maps.h	(revision 1956)
+++ lemon/concept/maps.h	(revision 1993)
@@ -20,5 +20,5 @@
 #define LEMON_CONCEPT_MAPS_H
 
-#include <lemon/utility.h>
+#include <lemon/bits/utility.h>
 #include <lemon/concept_check.h>
 
Index: lemon/concept/matrix_maps.h
===================================================================
--- lemon/concept/matrix_maps.h	(revision 1956)
+++ lemon/concept/matrix_maps.h	(revision 1993)
@@ -20,5 +20,5 @@
 #define LEMON_CONCEPT_MATRIX_MAPS_H
 
-#include <lemon/utility.h>
+#include <lemon/bits/utility.h>
 #include <lemon/concept_check.h>
 
Index: lemon/concept/path.h
===================================================================
--- lemon/concept/path.h	(revision 1956)
+++ lemon/concept/path.h	(revision 1993)
@@ -26,5 +26,5 @@
 #define LEMON_CONCEPT_PATH_H
 
-#include <lemon/invalid.h>
+#include <lemon/bits/invalid.h>
 #include <lemon/concept_check.h>
 
Index: lemon/concept/ugraph.h
===================================================================
--- lemon/concept/ugraph.h	(revision 1980)
+++ lemon/concept/ugraph.h	(revision 1993)
@@ -27,5 +27,5 @@
 #include <lemon/concept/graph_component.h>
 #include <lemon/concept/graph.h>
-#include <lemon/utility.h>
+#include <lemon/bits/utility.h>
 
 namespace lemon {
Index: lemon/dag_shortest_path.h
===================================================================
--- lemon/dag_shortest_path.h	(revision 1956)
+++ lemon/dag_shortest_path.h	(revision 1993)
@@ -26,5 +26,5 @@
 
 #include <lemon/list_graph.h>
-#include <lemon/invalid.h>
+#include <lemon/bits/invalid.h>
 #include <lemon/error.h>
 #include <lemon/maps.h>
Index: lemon/dfs.h
===================================================================
--- lemon/dfs.h	(revision 1981)
+++ lemon/dfs.h	(revision 1993)
@@ -26,5 +26,5 @@
 #include <lemon/list_graph.h>
 #include <lemon/graph_utils.h>
-#include <lemon/invalid.h>
+#include <lemon/bits/invalid.h>
 #include <lemon/error.h>
 #include <lemon/maps.h>
Index: lemon/dijkstra.h
===================================================================
--- lemon/dijkstra.h	(revision 1988)
+++ lemon/dijkstra.h	(revision 1993)
@@ -28,5 +28,5 @@
 #include <lemon/list_graph.h>
 #include <lemon/bin_heap.h>
-#include <lemon/invalid.h>
+#include <lemon/bits/invalid.h>
 #include <lemon/error.h>
 #include <lemon/maps.h>
Index: lemon/dimacs.h
===================================================================
--- lemon/dimacs.h	(revision 1956)
+++ lemon/dimacs.h	(revision 1993)
@@ -24,5 +24,5 @@
 #include <vector>
 #include <lemon/maps.h>
-#include <lemon/invalid.h>
+#include <lemon/bits/invalid.h>
 
 /// \ingroup dimacs_group
Index: lemon/euler.h
===================================================================
--- lemon/euler.h	(revision 1979)
+++ lemon/euler.h	(revision 1993)
@@ -17,5 +17,5 @@
  */
 
-#include<lemon/invalid.h>
+#include<lemon/bits/invalid.h>
 #include<lemon/topology.h>
 #include <list>
Index: lemon/floyd_warshall.h
===================================================================
--- lemon/floyd_warshall.h	(revision 1956)
+++ lemon/floyd_warshall.h	(revision 1993)
@@ -27,5 +27,5 @@
 #include <lemon/list_graph.h>
 #include <lemon/graph_utils.h>
-#include <lemon/invalid.h>
+#include <lemon/bits/invalid.h>
 #include <lemon/error.h>
 #include <lemon/matrix_maps.h>
Index: lemon/fredman_tarjan.h
===================================================================
--- lemon/fredman_tarjan.h	(revision 1979)
+++ lemon/fredman_tarjan.h	(revision 1993)
@@ -31,8 +31,8 @@
 #include <lemon/fib_heap.h>
 #include <lemon/radix_sort.h>
-#include <lemon/invalid.h>
+#include <lemon/bits/invalid.h>
 #include <lemon/error.h>
 #include <lemon/maps.h>
-#include <lemon/traits.h>
+#include <lemon/bits/traits.h>
 #include <lemon/graph_utils.h>
 
Index: lemon/full_graph.h
===================================================================
--- lemon/full_graph.h	(revision 1987)
+++ lemon/full_graph.h	(revision 1993)
@@ -26,6 +26,6 @@
 
 
-#include <lemon/invalid.h>
-#include <lemon/utility.h>
+#include <lemon/bits/invalid.h>
+#include <lemon/bits/utility.h>
 
 
Index: lemon/graph_adaptor.h
===================================================================
--- lemon/graph_adaptor.h	(revision 1991)
+++ lemon/graph_adaptor.h	(revision 1993)
@@ -28,5 +28,5 @@
 ///\author Marton Makai
 
-#include <lemon/invalid.h>
+#include <lemon/bits/invalid.h>
 #include <lemon/maps.h>
 
Index: lemon/graph_to_eps.h
===================================================================
--- lemon/graph_to_eps.h	(revision 1976)
+++ lemon/graph_to_eps.h	(revision 1993)
@@ -31,5 +31,5 @@
 #include <cmath>
 
-#include<lemon/invalid.h>
+#include<lemon/bits/invalid.h>
 #include<lemon/xy.h>
 #include<lemon/maps.h>
Index: lemon/graph_utils.h
===================================================================
--- lemon/graph_utils.h	(revision 1992)
+++ lemon/graph_utils.h	(revision 1993)
@@ -25,8 +25,8 @@
 #include <cmath>
 
-#include <lemon/invalid.h>
-#include <lemon/utility.h>
+#include <lemon/bits/invalid.h>
+#include <lemon/bits/utility.h>
 #include <lemon/maps.h>
-#include <lemon/traits.h>
+#include <lemon/bits/traits.h>
 
 #include <lemon/bits/alteration_notifier.h>
Index: lemon/grid_ugraph.h
===================================================================
--- lemon/grid_ugraph.h	(revision 1986)
+++ lemon/grid_ugraph.h	(revision 1993)
@@ -21,6 +21,6 @@
 
 #include <iostream>
-#include <lemon/invalid.h>
-#include <lemon/utility.h>
+#include <lemon/bits/invalid.h>
+#include <lemon/bits/utility.h>
 
 #include <lemon/bits/graph_extender.h>
Index: lemon/hypercube_graph.h
===================================================================
--- lemon/hypercube_graph.h	(revision 1986)
+++ lemon/hypercube_graph.h	(revision 1993)
@@ -22,6 +22,6 @@
 #include <iostream>
 #include <vector>
-#include <lemon/invalid.h>
-#include <lemon/utility.h>
+#include <lemon/bits/invalid.h>
+#include <lemon/bits/utility.h>
 #include <lemon/error.h>
 
Index: mon/invalid.h
===================================================================
--- lemon/invalid.h	(revision 1956)
+++ 	(revision )
@@ -1,54 +1,0 @@
-/* -*- C++ -*-
- *
- * This file is a part of LEMON, a generic C++ optimization library
- *
- * Copyright (C) 2003-2006
- * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Research Group on Combinatorial Optimization, EGRES).
- *
- * Permission to use, modify and distribute this software is granted
- * provided that this copyright notice appears in all copies. For
- * precise terms see the accompanying LICENSE file.
- *
- * This software is provided "AS IS" with no warranty of any kind,
- * express or implied, and with no claim as to its suitability for any
- * purpose.
- *
- */
-
-#ifndef LEMON_INVALID_H
-#define LEMON_INVALID_H
-
-///\file
-///\brief Definition of INVALID.
-
-namespace lemon {
-
-  /// Dummy type to make it easier to make invalid iterators.
-  
-  /// See \ref INVALID, how to use it.
-  
-  struct Invalid {
-  public:
-    bool operator==(Invalid) { return true;  }
-    bool operator!=(Invalid) { return false; }
-    bool operator< (Invalid) { return false; }
-  };
-  
-  /// Invalid iterators.
-  
-  /// \ref Invalid is a global type that converts to each iterator
-  /// in such a way that the value of the target iterator will be invalid.
-
-  //const Invalid &INVALID = *(Invalid *)0;
-
-#ifdef LEMON_ONLY_TEMPLATES
-  const Invalid INVALID = Invalid();
-#else
-  extern const Invalid INVALID;
-#endif
-
-} //namespace lemon
-
-#endif
-  
Index: lemon/iterable_maps.h
===================================================================
--- lemon/iterable_maps.h	(revision 1990)
+++ lemon/iterable_maps.h	(revision 1993)
@@ -17,6 +17,6 @@
  */
 
-#include <lemon/traits.h>
-#include <lemon/invalid.h>
+#include <lemon/bits/traits.h>
+#include <lemon/bits/invalid.h>
 
 #include <lemon/bits/default_map.h>
Index: lemon/johnson.h
===================================================================
--- lemon/johnson.h	(revision 1956)
+++ lemon/johnson.h	(revision 1993)
@@ -29,5 +29,5 @@
 #include <lemon/dijkstra.h>
 #include <lemon/bellman_ford.h>
-#include <lemon/invalid.h>
+#include <lemon/bits/invalid.h>
 #include <lemon/error.h>
 #include <lemon/maps.h>
Index: lemon/kruskal.h
===================================================================
--- lemon/kruskal.h	(revision 1979)
+++ lemon/kruskal.h	(revision 1993)
@@ -23,6 +23,6 @@
 #include <vector>
 #include <lemon/unionfind.h>
-#include <lemon/utility.h>
-#include <lemon/traits.h>
+#include <lemon/bits/utility.h>
+#include <lemon/bits/traits.h>
 
 /**
Index: lemon/lemon_reader.h
===================================================================
--- lemon/lemon_reader.h	(revision 1956)
+++ lemon/lemon_reader.h	(revision 1993)
@@ -36,5 +36,5 @@
 #include <lemon/error.h>
 #include <lemon/graph_utils.h>
-#include <lemon/utility.h>
+#include <lemon/bits/utility.h>
 #include <lemon/bits/item_reader.h>
 
Index: lemon/lemon_writer.h
===================================================================
--- lemon/lemon_writer.h	(revision 1956)
+++ lemon/lemon_writer.h	(revision 1993)
@@ -33,8 +33,8 @@
 
 #include <lemon/error.h>
-#include <lemon/invalid.h>
+#include <lemon/bits/invalid.h>
 #include <lemon/graph_utils.h>
 #include <lemon/bits/item_writer.h>
-#include <lemon/utility.h>
+#include <lemon/bits/utility.h>
 #include <lemon/maps.h>
 #include <lemon/xy.h>
Index: lemon/lp_base.h
===================================================================
--- lemon/lp_base.h	(revision 1956)
+++ lemon/lp_base.h	(revision 1993)
@@ -25,7 +25,7 @@
 #include<cmath>
 
-#include<lemon/utility.h>
+#include<lemon/bits/utility.h>
 #include<lemon/error.h>
-#include<lemon/invalid.h>
+#include<lemon/bits/invalid.h>
 
 ///\file
Index: lemon/map_iterator.h
===================================================================
--- lemon/map_iterator.h	(revision 1956)
+++ lemon/map_iterator.h	(revision 1993)
@@ -20,6 +20,6 @@
 #define LEMON_MAP_ITERATOR_H
 
-#include <lemon/traits.h>
-#include <lemon/utility.h>
+#include <lemon/bits/traits.h>
+#include <lemon/bits/utility.h>
 
 /// \ingroup gutils
Index: lemon/maps.h
===================================================================
--- lemon/maps.h	(revision 1956)
+++ lemon/maps.h	(revision 1993)
@@ -22,6 +22,6 @@
 #include <iterator>
 
-#include <lemon/utility.h>
-#include <lemon/traits.h>
+#include <lemon/bits/utility.h>
+#include <lemon/bits/traits.h>
 
 ///\file
Index: lemon/matrix_maps.h
===================================================================
--- lemon/matrix_maps.h	(revision 1956)
+++ lemon/matrix_maps.h	(revision 1993)
@@ -22,5 +22,5 @@
 
 #include <vector>
-#include <lemon/utility.h>
+#include <lemon/bits/utility.h>
 #include <lemon/maps.h>
 
Index: lemon/max_matching.h
===================================================================
--- lemon/max_matching.h	(revision 1956)
+++ lemon/max_matching.h	(revision 1993)
@@ -21,5 +21,5 @@
 
 #include <queue>
-#include <lemon/invalid.h>
+#include <lemon/bits/invalid.h>
 #include <lemon/unionfind.h>
 #include <lemon/graph_utils.h>
Index: lemon/min_cut.h
===================================================================
--- lemon/min_cut.h	(revision 1975)
+++ lemon/min_cut.h	(revision 1993)
@@ -27,5 +27,5 @@
 #include <lemon/linear_heap.h>
 
-#include <lemon/invalid.h>
+#include <lemon/bits/invalid.h>
 #include <lemon/error.h>
 #include <lemon/maps.h>
Index: lemon/path.h
===================================================================
--- lemon/path.h	(revision 1956)
+++ lemon/path.h	(revision 1993)
@@ -46,5 +46,5 @@
 #include <algorithm>
 
-#include <lemon/invalid.h>
+#include <lemon/bits/invalid.h>
 
 namespace lemon {
Index: lemon/preflow.h
===================================================================
--- lemon/preflow.h	(revision 1956)
+++ lemon/preflow.h	(revision 1993)
@@ -24,5 +24,5 @@
 
 #include <lemon/error.h>
-#include <lemon/invalid.h>
+#include <lemon/bits/invalid.h>
 #include <lemon/tolerance.h>
 #include <lemon/maps.h>
Index: lemon/prim.h
===================================================================
--- lemon/prim.h	(revision 1979)
+++ lemon/prim.h	(revision 1993)
@@ -26,8 +26,8 @@
 #include <lemon/list_graph.h>
 #include <lemon/bin_heap.h>
-#include <lemon/invalid.h>
+#include <lemon/bits/invalid.h>
 #include <lemon/error.h>
 #include <lemon/maps.h>
-#include <lemon/traits.h>
+#include <lemon/bits/traits.h>
 
 #include <lemon/concept/ugraph.h>
Index: lemon/smart_graph.h
===================================================================
--- lemon/smart_graph.h	(revision 1979)
+++ lemon/smart_graph.h	(revision 1993)
@@ -26,9 +26,9 @@
 #include <vector>
 
-#include <lemon/invalid.h>
+#include <lemon/bits/invalid.h>
 
 #include <lemon/bits/graph_extender.h>
 
-#include <lemon/utility.h>
+#include <lemon/bits/utility.h>
 #include <lemon/error.h>
 
Index: mon/traits.h
===================================================================
--- lemon/traits.h	(revision 1989)
+++ 	(revision )
@@ -1,300 +1,0 @@
-/* -*- C++ -*-
- *
- * This file is a part of LEMON, a generic C++ optimization library
- *
- * Copyright (C) 2003-2006
- * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Research Group on Combinatorial Optimization, EGRES).
- *
- * Permission to use, modify and distribute this software is granted
- * provided that this copyright notice appears in all copies. For
- * precise terms see the accompanying LICENSE file.
- *
- * This software is provided "AS IS" with no warranty of any kind,
- * express or implied, and with no claim as to its suitability for any
- * purpose.
- *
- */
-
-#ifndef LEMON_TRAITS_H
-#define LEMON_TRAITS_H
-
-#include <lemon/utility.h>
-
-///\file
-///\brief Traits for graphs and maps
-///
-
-namespace lemon {
-  template <typename _Graph, typename _Item>
-  class ItemSetTraits {};
-  
-
-  template <typename Graph, typename Enable = void>
-  struct NodeNotifierIndicator {
-    typedef InvalidType Type;
-  };
-  template <typename Graph>
-  struct NodeNotifierIndicator<
-    Graph, 
-    typename enable_if<typename Graph::NodeNotifier::Notifier, void>::type
-  > { 
-    typedef typename Graph::NodeNotifier Type;
-  };
-
-  template <typename _Graph>
-  class ItemSetTraits<_Graph, typename _Graph::Node> {
-  public:
-    
-    typedef _Graph Graph;
-
-    typedef typename Graph::Node Item;
-    typedef typename Graph::NodeIt ItemIt;
-
-    typedef typename NodeNotifierIndicator<Graph>::Type ItemNotifier;
-
-    template <typename _Value>
-    class Map : public Graph::template NodeMap<_Value> {
-    public:
-      typedef typename Graph::template NodeMap<_Value> Parent; 
-      typedef typename Parent::Value Value;
-
-      Map(const Graph& _graph) : Parent(_graph) {}
-      Map(const Graph& _graph, const Value& _value) 
-	: Parent(_graph, _value) {}
-
-     };
-
-  };
-
-  template <typename Graph, typename Enable = void>
-  struct EdgeNotifierIndicator {
-    typedef InvalidType Type;
-  };
-  template <typename Graph>
-  struct EdgeNotifierIndicator<
-    Graph, 
-    typename enable_if<typename Graph::EdgeNotifier::Notifier, void>::type
-  > { 
-    typedef typename Graph::EdgeNotifier Type;
-  };
-
-  template <typename _Graph>
-  class ItemSetTraits<_Graph, typename _Graph::Edge> {
-  public:
-    
-    typedef _Graph Graph;
-
-    typedef typename Graph::Edge Item;
-    typedef typename Graph::EdgeIt ItemIt;
-
-    typedef typename EdgeNotifierIndicator<Graph>::Type ItemNotifier;
-
-    template <typename _Value>
-    class Map : public Graph::template EdgeMap<_Value> {
-    public:
-      typedef typename Graph::template EdgeMap<_Value> Parent; 
-      typedef typename Parent::Value Value;
-
-      Map(const Graph& _graph) : Parent(_graph) {}
-      Map(const Graph& _graph, const Value& _value) 
-	: Parent(_graph, _value) {}
-    };
-
-  };
-
-  template <typename Graph, typename Enable = void>
-  struct UEdgeNotifierIndicator {
-    typedef InvalidType Type;
-  };
-  template <typename Graph>
-  struct UEdgeNotifierIndicator<
-    Graph, 
-    typename enable_if<typename Graph::UEdgeNotifier::Notifier, void>::type
-  > { 
-    typedef typename Graph::UEdgeNotifier Type;
-  };
-
-  template <typename _Graph>
-  class ItemSetTraits<_Graph, typename _Graph::UEdge> {
-  public:
-    
-    typedef _Graph Graph;
-
-    typedef typename Graph::UEdge Item;
-    typedef typename Graph::UEdgeIt ItemIt;
-
-    typedef typename UEdgeNotifierIndicator<Graph>::Type ItemNotifier;
-
-    template <typename _Value>
-    class Map : public Graph::template UEdgeMap<_Value> {
-    public:
-      typedef typename Graph::template UEdgeMap<_Value> Parent; 
-      typedef typename Parent::Value Value;
-
-      Map(const Graph& _graph) : Parent(_graph) {}
-      Map(const Graph& _graph, const Value& _value) 
-	: Parent(_graph, _value) {}
-    };
-
-  };
-
-  template <typename Graph, typename Enable = void>
-  struct ANodeNotifierIndicator {
-    typedef InvalidType Type;
-  };
-  template <typename Graph>
-  struct ANodeNotifierIndicator<
-    Graph, 
-    typename enable_if<typename Graph::ANodeNotifier::Notifier, void>::type
-  > { 
-    typedef typename Graph::ANodeNotifier Type;
-  };
-
-  template <typename _Graph>
-  class ItemSetTraits<_Graph, typename _Graph::ANode> {
-  public:
-    
-    typedef _Graph Graph;
-
-    typedef typename Graph::ANode Item;
-    typedef typename Graph::ANodeIt ItemIt;
-
-    typedef typename ANodeNotifierIndicator<Graph>::Type ItemNotifier;
-
-    template <typename _Value>
-    class Map : public Graph::template ANodeMap<_Value> {
-    public:
-      typedef typename Graph::template ANodeMap<_Value> Parent; 
-      typedef typename Parent::Value Value;
-
-      Map(const Graph& _graph) : Parent(_graph) {}
-      Map(const Graph& _graph, const Value& _value) 
-	: Parent(_graph, _value) {}
-    };
-
-  };
-
-  template <typename Graph, typename Enable = void>
-  struct BNodeNotifierIndicator {
-    typedef InvalidType Type;
-  };
-  template <typename Graph>
-  struct BNodeNotifierIndicator<
-    Graph, 
-    typename enable_if<typename Graph::BNodeNotifier::Notifier, void>::type
-  > { 
-    typedef typename Graph::BNodeNotifier Type;
-  };
-
-  template <typename _Graph>
-  class ItemSetTraits<_Graph, typename _Graph::BNode> {
-  public:
-    
-    typedef _Graph Graph;
-
-    typedef typename Graph::BNode Item;
-    typedef typename Graph::BNodeIt ItemIt;
-
-    typedef typename BNodeNotifierIndicator<Graph>::Type ItemNotifier;
-
-    template <typename _Value>
-    class Map : public Graph::template BNodeMap<_Value> {
-    public:
-      typedef typename Graph::template BNodeMap<_Value> Parent; 
-      typedef typename Parent::Value Value;
-
-      Map(const Graph& _graph) : Parent(_graph) {}
-      Map(const Graph& _graph, const Value& _value) 
-	: Parent(_graph, _value) {}
-    };
-
-  };
-
-
-  template <typename Map, typename Enable = void>
-  struct MapTraits {
-    typedef False ReferenceMapTag;
-
-    typedef typename Map::Key Key;
-    typedef typename Map::Value Value;
-
-    typedef const Value ConstReturnValue;
-    typedef const Value ReturnValue;
-  };
-
-  template <typename Map>
-  struct MapTraits<
-    Map, typename enable_if<typename Map::ReferenceMapTag, void>::type > 
-  {
-    typedef True ReferenceMapTag;
-    
-    typedef typename Map::Key Key;
-    typedef typename Map::Value Value;
-
-    typedef typename Map::ConstReference ConstReturnValue;
-    typedef typename Map::Reference ReturnValue;
-
-    typedef typename Map::ConstReference ConstReference; 
-    typedef typename Map::Reference Reference;
- };
-
-  // Indicators for the tags
-
-  template <typename Graph, typename Enable = void>
-  struct NodeNumTagIndicator {
-    static const bool value = false;
-  };
-
-  template <typename Graph>
-  struct NodeNumTagIndicator<
-    Graph, 
-    typename enable_if<typename Graph::NodeNumTag, void>::type
-  > {
-    static const bool value = true;
-  };
-
-  template <typename Graph, typename Enable = void>
-  struct EdgeNumTagIndicator {
-    static const bool value = false;
-  };
-
-  template <typename Graph>
-  struct EdgeNumTagIndicator<
-    Graph, 
-    typename enable_if<typename Graph::EdgeNumTag, void>::type
-  > {
-    static const bool value = true;
-  };
-
-  template <typename Graph, typename Enable = void>
-  struct FindEdgeTagIndicator {
-    static const bool value = false;
-  };
-
-  template <typename Graph>
-  struct FindEdgeTagIndicator<
-    Graph, 
-    typename enable_if<typename Graph::FindEdgeTag, void>::type
-  > {
-    static const bool value = true;
-  };
-
-  template <typename Graph, typename Enable = void>
-  struct UndirectedTagIndicator {
-    static const bool value = false;
-  };
-
-  template <typename Graph>
-  struct UndirectedTagIndicator<
-    Graph, 
-    typename enable_if<typename Graph::UndirectedTag, void>::type
-  > {
-    static const bool value = true;
-  };
-
-
-
-}
-
-#endif // LEMON_MAPS_H
Index: lemon/ugraph_adaptor.h
===================================================================
--- lemon/ugraph_adaptor.h	(revision 1991)
+++ lemon/ugraph_adaptor.h	(revision 1993)
@@ -28,10 +28,10 @@
 ///\author Balazs Dezso
 
-#include <lemon/invalid.h>
+#include <lemon/bits/invalid.h>
 #include <lemon/maps.h>
 
 #include <lemon/bits/graph_adaptor_extender.h>
 
-#include <lemon/traits.h>
+#include <lemon/bits/traits.h>
 
 #include <iostream>
Index: lemon/unionfind.h
===================================================================
--- lemon/unionfind.h	(revision 1956)
+++ lemon/unionfind.h	(revision 1993)
@@ -30,5 +30,5 @@
 #include <algorithm>
 
-#include <lemon/invalid.h>
+#include <lemon/bits/invalid.h>
 
 namespace lemon {
Index: mon/utility.h
===================================================================
--- lemon/utility.h	(revision 1989)
+++ 	(revision )
@@ -1,137 +1,0 @@
-/* -*- C++ -*-
- *
- * This file is a part of LEMON, a generic C++ optimization library
- *
- * Copyright (C) 2003-2006
- * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Research Group on Combinatorial Optimization, EGRES).
- *
- * Permission to use, modify and distribute this software is granted
- * provided that this copyright notice appears in all copies. For
- * precise terms see the accompanying LICENSE file.
- *
- * This software is provided "AS IS" with no warranty of any kind,
- * express or implied, and with no claim as to its suitability for any
- * purpose.
- *
- */
-
-// This file contains a modified version of the enable_if library from BOOST.
-// See the appropriate copyright notice below.
-
-// Boost enable_if library
-
-// Copyright 2003 © The Trustees of Indiana University.
-
-// Use, modification, and distribution is subject to the Boost Software
-// License, Version 1.0. (See accompanying file LICENSE_1_0.txt or copy at
-// http://www.boost.org/LICENSE_1_0.txt)
-
-//    Authors: Jaakko Järvi (jajarvi at osl.iu.edu)
-//             Jeremiah Willcock (jewillco at osl.iu.edu)
-//             Andrew Lumsdaine (lums at osl.iu.edu)
-
-
-#ifndef LEMON_UTILITY_H
-#define LEMON_UTILITY_H
-
-///\file
-///\brief Miscellaneous basic utilities
-///
-///\todo Please rethink the organisation of the basic files like this.
-///E.g. this file might be merged with invalid.h.
-
-
-namespace lemon
-{
-
-  /// Basic type for defining "tags". A "YES" condition for \c enable_if.
-
-  /// Basic type for defining "tags". A "YES" condition for \c enable_if.
-  ///
-  ///\sa False
-  ///
-  /// \todo This should go to a separate "basic_types.h" (or something)
-  /// file.
-  struct True {
-    ///\e
-    static const bool value = true;
-  };
-
-  /// Basic type for defining "tags". A "NO" condition for \c enable_if.
-
-  /// Basic type for defining "tags". A "NO" condition for \c enable_if.
-  ///
-  ///\sa True
-  struct False {
-    ///\e
-    static const bool value = false;
-  };
-
-
-  class InvalidType {
-  private:
-    InvalidType();
-  };
-  
-
-  template <typename T>
-  struct Wrap {
-    const T &value;
-    Wrap(const T &t) : value(t) {}
-  };
-
-  /**************** dummy class to avoid ambiguity ****************/
-
-  template<int T> struct dummy { dummy(int) {} };
-
-  /**************** enable_if from BOOST ****************/
- 
-  template <bool B, class T = void>
-  struct enable_if_c {
-    typedef T type;
-  };
-
-  template <class T>
-  struct enable_if_c<false, T> {};
-
-  template <class Cond, class T = void> 
-  struct enable_if : public enable_if_c<Cond::value, T> {};
-
-  template <bool B, class T>
-  struct lazy_enable_if_c {
-    typedef typename T::type type;
-  };
-
-  template <class T>
-  struct lazy_enable_if_c<false, T> {};
-
-  template <class Cond, class T> 
-  struct lazy_enable_if : public lazy_enable_if_c<Cond::value, T> {};
-
-
-  template <bool B, class T = void>
-  struct disable_if_c {
-    typedef T type;
-  };
-
-  template <class T>
-  struct disable_if_c<true, T> {};
-
-  template <class Cond, class T = void> 
-  struct disable_if : public disable_if_c<Cond::value, T> {};
-
-  template <bool B, class T>
-  struct lazy_disable_if_c {
-    typedef typename T::type type;
-  };
-
-  template <class T>
-  struct lazy_disable_if_c<true, T> {};
-
-  template <class Cond, class T> 
-  struct lazy_disable_if : public lazy_disable_if_c<Cond::value, T> {};
-
-} // namespace lemon
-
-#endif
Index: lemon/xy.h
===================================================================
--- lemon/xy.h	(revision 1974)
+++ lemon/xy.h	(revision 1993)
@@ -21,5 +21,5 @@
 
 #include <iostream>
-#include <lemon/utility.h>
+#include <lemon/bits/utility.h>
 
 ///\ingroup misc
Index: test/max_matching_test.cc
===================================================================
--- test/max_matching_test.cc	(revision 1956)
+++ test/max_matching_test.cc	(revision 1993)
@@ -24,5 +24,4 @@
 
 #include "test_tools.h"
-#include <lemon/invalid.h>
 #include <lemon/list_graph.h>
 #include <lemon/max_matching.h>
Index: test/test_tools.h
===================================================================
--- test/test_tools.h	(revision 1956)
+++ test/test_tools.h	(revision 1993)
@@ -26,6 +26,6 @@
 #include <ctime>
 
-#include <lemon/invalid.h>
 #include <lemon/concept_check.h>
+#include <lemon/concept/graph.h>
 
 using namespace lemon;
